import { __name } from '../../chunk-2JTKI4GS.mjs';
import { createClassDecorator, createProxy } from '@sapphire/decorators';
import { container } from '@sapphire/framework';
import { SlashCommandSubcommandBuilder } from '@discordjs/builders';
import { analizeSubCommandParsed, analizeSubcommandGroupParsed } from './functions.mjs';

var RegisterSubCommand = /* @__PURE__ */ __name((parentCommandName, slashSubcommand) => {
  return createClassDecorator(
    (target) => createProxy(target, {
      construct: /* @__PURE__ */ __name((ctor, [context, baseOptions]) => {
        const slashSubcommandParsed = typeof slashSubcommand === "function" ? slashSubcommand(new SlashCommandSubcommandBuilder(), container) : slashSubcommand;
        const ctr = new ctor(context, {
          ...baseOptions,
          name: container.client.options.subcommandsAdvanced?.nameCommandsAutogenerated === true ? `${parentCommandName}/${slashSubcommandParsed.name}` : baseOptions.name
        });
        return analizeSubCommandParsed(ctr, parentCommandName, slashSubcommandParsed);
      }, "construct")
    })
  );
}, "RegisterSubCommand");
var RegisterSubCommandGroup = /* @__PURE__ */ __name((parentCommandName, groupName, slashSubcommand) => {
  return createClassDecorator(
    (target) => createProxy(target, {
      construct: /* @__PURE__ */ __name((ctor, [context, baseOptions]) => {
        const slashSubcommandParsed = typeof slashSubcommand === "function" ? slashSubcommand(new SlashCommandSubcommandBuilder(), container) : slashSubcommand;
        const ctr = new ctor(context, {
          ...baseOptions,
          name: container.client.options.subcommandsAdvanced?.nameCommandsAutogenerated === true ? `${parentCommandName}/${groupName}/${slashSubcommandParsed.name}` : baseOptions.name
        });
        return analizeSubcommandGroupParsed(ctr, parentCommandName, groupName, slashSubcommandParsed);
      }, "construct")
    })
  );
}, "RegisterSubCommandGroup");

export { RegisterSubCommand, RegisterSubCommandGroup };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=decorators.mjs.map